ldns documentation

- Main Page
- Related Pages
- Data Structures
- Files

- File List
- Globals

Macros | Functions
dnssec_zone.c File Reference

Go to the source code of this file.

## Macros
#define | FASTER_DNSSEC_ZONE_NEW_FRM_FP 1 /* Because of L2 cache efficiency */

## Functions
ldns_dnssec_rrs * | ldns_dnssec_rrs_new (void)
| Creates a new entry for 1 pointer to an rr and 1 pointer to the next rrs. More...
void | ldns_dnssec_rrs_free (ldns_dnssec_rrs *rrs)
| Frees the list of rrs, but not the individual ldns_rr records contained in the list. More...
void | ldns_dnssec_rrs_deep_free (ldns_dnssec_rrs *rrs)
| Frees the list of rrs, and the individual ldns_rr records contained in the list. More...
ldns_status | ldns_dnssec_rrs_add_rr (ldns_dnssec_rrs *rrs, ldns_rr *rr)
| Adds an RR to the list of RRs. More...
void | ldns_dnssec_rrs_print_fmt (FILE *out, const ldns_output_format *fmt, ldns_dnssec_rrs *rrs)
| Prints the given rrs to the file descriptor. More...
void | ldns_dnssec_rrs_print (FILE *out, ldns_dnssec_rrs *rrs)
| Prints the given rrs to the file descriptor. More...
ldns_dnssec_rrsets * | ldns_dnssec_rrsets_new (void)
| Creates a new list (entry) of RRsets. More...
void | ldns_dnssec_rrsets_free (ldns_dnssec_rrsets *rrsets)
| Frees the list of rrsets and their rrs, but not the ldns_rr records in the sets. More...
void | ldns_dnssec_rrsets_deep_free (ldns_dnssec_rrsets *rrsets)
| Frees the list of rrsets and their rrs, and the ldns_rr records in the sets. More...
ldns_rr_type | ldns_dnssec_rrsets_type (ldns_dnssec_rrsets *rrsets)
| Returns the rr type of the rrset (that is head of the given list) More...
ldns_status | ldns_dnssec_rrsets_set_type (ldns_dnssec_rrsets *rrsets, ldns_rr_type type)
| Sets the RR type of the rrset (that is head of the given list) More...
ldns_status | ldns_dnssec_rrsets_add_rr (ldns_dnssec_rrsets *rrsets, ldns_rr *rr)
| Add an ldns_rr to the corresponding RRset in the given list of RRsets. More...
void | ldns_dnssec_rrsets_print_fmt (FILE *out, const ldns_output_format *fmt, ldns_dnssec_rrsets *rrsets, bool follow)
void | ldns_dnssec_rrsets_print (FILE *out, ldns_dnssec_rrsets *rrsets, bool follow)
ldns_dnssec_name * | ldns_dnssec_name_new (void)
| Create a new data structure for a dnssec name. More...
ldns_dnssec_name * | ldns_dnssec_name_new_frm_rr (ldns_rr *rr)
| Create a new data structure for a dnssec name for the given RR. More...
void | ldns_dnssec_name_free (ldns_dnssec_name *name)
| Frees the name structure and its rrs and rrsets. More...
void | ldns_dnssec_name_deep_free (ldns_dnssec_name *name)
| Frees the name structure and its rrs and rrsets. More...
ldns_rdf * | ldns_dnssec_name_name (ldns_dnssec_name *name)
| Returns the domain name of the given dnssec_name structure. More...
bool | ldns_dnssec_name_is_glue (ldns_dnssec_name *name)
| Returns if dnssec_name structure is marked as glue. More...
void | ldns_dnssec_name_set_name (ldns_dnssec_name *rrset, ldns_rdf *dname)
| Sets the domain name of the given dnssec_name structure. More...
void | ldns_dnssec_name_set_nsec (ldns_dnssec_name *rrset, ldns_rr *nsec)
| Sets the NSEC(3) RR of the given dnssec_name structure. More...
int | ldns_dnssec_name_cmp (const void *a, const void *b)
| Compares the domain names of the two arguments in their canonical ordening. More...
ldns_status | ldns_dnssec_name_add_rr (ldns_dnssec_name *name, ldns_rr *rr)
| Inserts the given rr at the right place in the current dnssec_name No checking is done whether the name matches. More...
ldns_dnssec_rrsets * | ldns_dnssec_name_find_rrset (ldns_dnssec_name *name, ldns_rr_type type)
| Find the RRset with the given type in within this name structure. More...
ldns_dnssec_rrsets * | ldns_dnssec_zone_find_rrset (ldns_dnssec_zone *zone, ldns_rdf *dname, ldns_rr_type type)
| Find the RRset with the given name and type in the zone. More...
void | ldns_dnssec_name_print_fmt (FILE *out, const ldns_output_format *fmt, ldns_dnssec_name *name)
| Prints the RRs in the dnssec name structure to the given file descriptor. More...
void | ldns_dnssec_name_print (FILE *out, ldns_dnssec_name *name)
| Prints the RRs in the dnssec name structure to the given file descriptor. More...
ldns_dnssec_zone * | ldns_dnssec_zone_new (void)
| Creates a new dnssec_zone structure. More...
ldns_status | ldns_dnssec_zone_new_frm_fp_l (ldns_dnssec_zone **z, FILE *fp, ldns_rdf *origin, uint32_t ttl, ldns_rr_class c __attribute__((unused)), int *line_nr)
ldns_status | ldns_dnssec_zone_new_frm_fp (ldns_dnssec_zone **z, FILE *fp, ldns_rdf *origin, uint32_t ttl, ldns_rr_class c __attribute__((unused)))
void | ldns_dnssec_zone_free (ldns_dnssec_zone *zone)
| Frees the given zone structure, and its rbtree of dnssec_names Individual ldns_rr RRs within those names are not freed. More...
void | ldns_dnssec_zone_deep_free (ldns_dnssec_zone *zone)
| Frees the given zone structure, and its rbtree of dnssec_names Individual ldns_rr RRs within those names are also freed. More...
int | ldns_dname_compare_v (const void *a, const void *b)
| Given in dnssec_zone.c, also used in dnssec_sign.c:w. More...
ldns_status | ldns_dnssec_zone_add_rr (ldns_dnssec_zone *zone, ldns_rr *rr)
| Adds the given RR to the zone. More...
void | ldns_dnssec_zone_names_print_fmt (FILE *out, const ldns_output_format *fmt, ldns_rbtree_t *tree, bool print_soa)
void | ldns_dnssec_zone_names_print (FILE *out, ldns_rbtree_t *tree, bool print_soa)
void | ldns_dnssec_zone_print_fmt (FILE *out, const ldns_output_format *fmt, ldns_dnssec_zone *zone)
| Prints the complete zone to the given file descriptor. More...
void | ldns_dnssec_zone_print (FILE *out, ldns_dnssec_zone *zone)
| Prints the complete zone to the given file descriptor. More...
ldns_status | ldns_dnssec_zone_add_empty_nonterminals (ldns_dnssec_zone *zone)
| Adds explicit dnssec_name structures for the empty nonterminals in this zone. More...
bool | ldns_dnssec_zone_is_nsec3_optout (ldns_dnssec_zone *zone)
| If a NSEC3PARAM is available in the apex, walks the zone and returns true on the first optout nsec3. More...

## Macro Definition Documentation

#define FASTER_DNSSEC_ZONE_NEW_FRM_FP 1 /* Because of L2 cache efficiency */

Definition at line 594 of file dnssec_zone.c.

## Function Documentation

ldns_dnssec_rrs* ldns_dnssec_rrs_new | ( | void |  | ) |

Creates a new entry for 1 pointer to an rr and 1 pointer to the next rrs.

Returns
  the allocated data

Definition at line 10 of file dnssec_zone.c.

References INLINE, LDNS_FREE, LDNS_MALLOC, ldns_rr_free(), ldns_struct_dnssec_rrs::next, and ldns_struct_dnssec_rrs::rr.

void ldns_dnssec_rrs_free | ( | ldns_dnssec_rrs * | rrs | ) |

Frees the list of rrs, but not the individual ldns_rr records contained in the list.

Parameters

  [in] | rrs | the data structure to free

Definition at line 35 of file dnssec_zone.c.

void ldns_dnssec_rrs_deep_free | ( | ldns_dnssec_rrs * | rrs | ) |

Frees the list of rrs, and the individual ldns_rr records contained in the list.

Parameters

  [in] | rrs | the data structure to free

Definition at line 41 of file dnssec_zone.c.

ldns_status ldns_dnssec_rrs_add_rr | ( | ldns_dnssec_rrs * | rrs,
|  | ldns_rr * | rr
| ) |  |

Adds an RR to the list of RRs.

The list will remain ordered. If an equal RR already exists, this RR will not be added.

Parameters

  [in] | rrs | the list to add to
  [in] | rr | the RR to add

Returns
  LDNS_STATUS_OK on success

Definition at line 47 of file dnssec_zone.c.

References ldns_dnssec_rrs_add_rr(), ldns_dnssec_rrs_new(), ldns_rr_compare(), LDNS_STATUS_ERR, LDNS_STATUS_OK, ldns_struct_dnssec_rrs::next, and ldns_struct_dnssec_rrs::rr.

void ldns_dnssec_rrs_print_fmt | ( | FILE * | out,
|  | const ldns_output_format * | fmt,
|  | ldns_dnssec_rrs * | rrs
| ) |  |

Prints the given rrs to the file descriptor.

Parameters

  [in] | out | the file descriptor to print to
  [in] | fmt | the format of the textual representation
  [in] | rrs | the list of RRs to print

Definition at line 80 of file dnssec_zone.c.

References ldns_struct_output_format::flags, LDNS_COMMENT_LAYOUT, ldns_dnssec_rrs_print_fmt(), ldns_rr_print_fmt(), ldns_struct_dnssec_rrs::next, and ldns_struct_dnssec_rrs::rr.

void ldns_dnssec_rrs_print | ( | FILE * | out,
|  | ldns_dnssec_rrs * | rrs
| ) |  |

Prints the given rrs to the file descriptor.

Parameters

  [in] | out | the file descriptor to print to
  [in] | rrs | the list of RRs to print

Definition at line 97 of file dnssec_zone.c.

References ldns_dnssec_rrs_print_fmt(), and ldns_output_format_default.

ldns_dnssec_rrsets* ldns_dnssec_rrsets_new | ( | void |  | ) |

Creates a new list (entry) of RRsets.

Returns
  the newly allocated structure

Definition at line 104 of file dnssec_zone.c.

References INLINE, LDNS_FREE, LDNS_MALLOC, ldns_struct_dnssec_rrsets::next, ldns_struct_dnssec_rrsets::rrs, ldns_struct_dnssec_rrsets::signatures, and ldns_struct_dnssec_rrsets::type.

void ldns_dnssec_rrsets_free | ( | ldns_dnssec_rrsets * | rrsets | ) |

Frees the list of rrsets and their rrs, but not the ldns_rr records in the sets.

Parameters

  [in] | rrsets | the data structure to free

Definition at line 134 of file dnssec_zone.c.

void ldns_dnssec_rrsets_deep_free | ( | ldns_dnssec_rrsets * | rrsets | ) |

Frees the list of rrsets and their rrs, and the ldns_rr records in the sets.

Parameters

  [in] | rrsets | the data structure to free

Definition at line 140 of file dnssec_zone.c.

ldns_rr_type ldns_dnssec_rrsets_type | ( | ldns_dnssec_rrsets * | rrsets | ) |

Returns the rr type of the rrset (that is head of the given list)

Parameters

  [in] | rrsets | the rrset to get the type of

Returns
  the rr type

Definition at line 146 of file dnssec_zone.c.

References ldns_struct_dnssec_rrsets::type.

ldns_status ldns_dnssec_rrsets_set_type | ( | ldns_dnssec_rrsets * | rrsets,
|  | ldns_rr_type | type
| ) |  |

Sets the RR type of the rrset (that is head of the given list)

Parameters

  [in] | rrsets | the rrset to set the type of
  [in] | type | the type to set

Returns
  LDNS_STATUS_OK on success

Definition at line 156 of file dnssec_zone.c.

References ldns_dnssec_rrs_new(), ldns_dnssec_rrsets_new(), ldns_rdf2rr_type(), ldns_rr_get_type(), ldns_rr_rrsig_typecovered(), LDNS_RR_TYPE_RRSIG, LDNS_STATUS_ERR, LDNS_STATUS_OK, ldns_struct_dnssec_rrs::rr, ldns_struct_dnssec_rrsets::rrs, ldns_struct_dnssec_rrsets::signatures, and ldns_struct_dnssec_rrsets::type.

ldns_status ldns_dnssec_rrsets_add_rr | ( | ldns_dnssec_rrsets * | rrsets,
|  | ldns_rr * | rr
| ) |  |

Add an ldns_rr to the corresponding RRset in the given list of RRsets.

If it is not present, add it as a new RRset with 1 record.

Parameters

  [in] | rrsets | the list of rrsets to add the RR to
  [in] | rr | the rr to add to the list of rrsets

Returns
  LDNS_STATUS_OK on success

Definition at line 193 of file dnssec_zone.c.

References ldns_struct_output_format::flags, LDNS_COMMENT_LAYOUT, ldns_dnssec_rrs_add_rr(), ldns_dnssec_rrs_new(), ldns_dnssec_rrs_print_fmt(), ldns_dnssec_rrsets_add_rr(), ldns_dnssec_rrsets_new(), ldns_dnssec_rrsets_type(), ldns_rdf2rr_type(), ldns_rr_get_type(), ldns_rr_rrsig_typecovered(), LDNS_RR_TYPE_RRSIG, LDNS_RR_TYPE_SOA, LDNS_STATUS_ERR, LDNS_STATUS_OK, ldns_struct_dnssec_rrsets::next, ldns_struct_dnssec_rrs::rr, ldns_struct_dnssec_rrsets::rrs, ldns_struct_dnssec_rrsets::signatures, and ldns_struct_dnssec_rrsets::type.

void ldns_dnssec_rrsets_print_fmt | ( | FILE * | out,
|  | const ldns_output_format * | fmt,
|  | ldns_dnssec_rrsets * | rrsets,
|  | bool | follow
| ) |  |

Definition at line 302 of file dnssec_zone.c.

void ldns_dnssec_rrsets_print | ( | FILE * | out,
|  | ldns_dnssec_rrsets * | rrsets,
|  | bool | follow
| ) |  |

Definition at line 310 of file dnssec_zone.c.

References ldns_dnssec_rrsets_print_fmt(), and ldns_output_format_default.

ldns_dnssec_name* ldns_dnssec_name_new | ( | void |  | ) |

Create a new data structure for a dnssec name.

Returns
  the allocated structure

Definition at line 317 of file dnssec_zone.c.

References LDNS_CALLOC.

ldns_dnssec_name* ldns_dnssec_name_new_frm_rr | ( | ldns_rr * | rr | ) |

Create a new data structure for a dnssec name for the given RR.

Parameters

  [in] | rr | the RR to derive properties from, and to add to the name

Definition at line 342 of file dnssec_zone.c.

References ldns_struct_dnssec_name::hashed_name, INLINE, ldns_dnssec_name_add_rr(), ldns_dnssec_name_free(), ldns_dnssec_name_new(), LDNS_FREE, ldns_rdf_deep_free(), ldns_rr_free(), ldns_rr_owner(), LDNS_STATUS_OK, ldns_struct_dnssec_name::name, ldns_struct_dnssec_name::name_alloced, ldns_struct_dnssec_name::nsec, ldns_struct_dnssec_name::nsec_signatures, and ldns_struct_dnssec_name::rrsets.

void ldns_dnssec_name_free | ( | ldns_dnssec_name * | name | ) |

Frees the name structure and its rrs and rrsets.

Individual ldns_rr records therein are not freed

Parameters

  [in] | name | the structure to free

Definition at line 382 of file dnssec_zone.c.

void ldns_dnssec_name_deep_free | ( | ldns_dnssec_name * | name | ) |

Frees the name structure and its rrs and rrsets.

Individual ldns_rr records contained in the name are also freed

Parameters

  [in] | name | the structure to free

Definition at line 388 of file dnssec_zone.c.

ldns_rdf* ldns_dnssec_name_name | ( | ldns_dnssec_name * | name | ) |

Returns the domain name of the given dnssec_name structure.

Parameters

  [in] | name | the dnssec name to get the domain name from

Returns
  the domain name

Definition at line 394 of file dnssec_zone.c.

References ldns_struct_dnssec_name::name.

bool ldns_dnssec_name_is_glue | ( | ldns_dnssec_name * | name | ) |

Returns if dnssec_name structure is marked as glue.

The ldns_dnssec_zone_mark_glue() function has to be called on a zone before using this function. Only names that have only glue rrsets will be marked. Names that have other occluded rrsets and names containing glue on the delegation point will NOT be marked!

Parameters

  [in] | name | the dnssec name to get the domain name from

Returns
  true if the structure is marked as glue, false otherwise.

Definition at line 403 of file dnssec_zone.c.

References ldns_struct_dnssec_name::is_glue.

void ldns_dnssec_name_set_name | ( | ldns_dnssec_name * | name,
|  | ldns_rdf * | dname
| ) |  |

Sets the domain name of the given dnssec_name structure.

Parameters

  [in] | name | the dnssec name to set the domain name of
  [in] | dname | the domain name to set it to. This data is not copied.

Definition at line 412 of file dnssec_zone.c.

References ldns_struct_dnssec_name::name.

void ldns_dnssec_name_set_nsec | ( | ldns_dnssec_name * | name,
|  | ldns_rr * | nsec
| ) |  |

Sets the NSEC(3) RR of the given dnssec_name structure.

Parameters

  [in] | name | the dnssec name to set the domain name of
  [in] | nsec | the nsec rr to set it to. This data is not copied.

Definition at line 422 of file dnssec_zone.c.

References ldns_struct_dnssec_name::nsec.

int ldns_dnssec_name_cmp | ( | const void * | a,
|  | const void * | b
| ) |  |

Compares the domain names of the two arguments in their canonical ordening.

Parameters

  [in] | a | The first dnssec_name to compare
  [in] | b | The second dnssec_name to compare

Returns
  -1 if the domain name of a comes before that of b in canonical ordening, 1 if it is the other way around, and 0 if they are equal

Definition at line 430 of file dnssec_zone.c.

References ldns_dname_compare(), and ldns_dnssec_name_name().

ldns_status ldns_dnssec_name_add_rr | ( | ldns_dnssec_name * | name,
|  | ldns_rr * | rr
| ) |  |

Inserts the given rr at the right place in the current dnssec_name No checking is done whether the name matches.

Parameters

  [in] | name | The ldns_dnssec_name to add the RR to
  [in] | rr | The RR to add

Returns
  LDNS_STATUS_OK on success, error code otherwise

Definition at line 448 of file dnssec_zone.c.

References ldns_dnssec_rrs_add_rr(), ldns_dnssec_rrs_new(), ldns_dnssec_rrsets_add_rr(), ldns_dnssec_rrsets_new(), ldns_rdf2rr_type(), ldns_rr_get_type(), ldns_rr_rrsig_typecovered(), LDNS_RR_TYPE_NSEC, LDNS_RR_TYPE_NSEC3, LDNS_RR_TYPE_RRSIG, LDNS_STATUS_ERR, LDNS_STATUS_OK, ldns_struct_dnssec_name::nsec, ldns_struct_dnssec_name::nsec_signatures, ldns_struct_dnssec_rrs::rr, and ldns_struct_dnssec_name::rrsets.

ldns_dnssec_rrsets* ldns_dnssec_name_find_rrset | ( | ldns_dnssec_name * | name,
|  | ldns_rr_type | type
| ) |  |

Find the RRset with the given type in within this name structure.

Parameters

  [in] | name | the name to find the RRset in
  [in] | type | the type of the RRset to find

Returns
  the RRset, or NULL if not present

Definition at line 492 of file dnssec_zone.c.

References ldns_struct_dnssec_rrsets::next, ldns_struct_dnssec_name::rrsets, and ldns_struct_dnssec_rrsets::type.

ldns_dnssec_rrsets* ldns_dnssec_zone_find_rrset | ( | ldns_dnssec_zone * | zone,
|  | ldns_rdf * | dname,
|  | ldns_rr_type | type
| ) |  |

Find the RRset with the given name and type in the zone.

Parameters

  [in] | zone | the zone structure to find the RRset in
  [in] | dname | the domain name of the RRset to find
  [in] | type | the type of the RRset to find

Returns
  the RRset, or NULL if not present

Definition at line 508 of file dnssec_zone.c.

References ldns_rbnode_t::data, ldns_struct_output_format::flags, LDNS_COMMENT_LAYOUT, ldns_dnssec_name_find_rrset(), ldns_dnssec_rrs_print_fmt(), ldns_rbtree_search(), ldns_rdf_print(), ldns_rr_print_fmt(), ldns_struct_dnssec_name::name, ldns_struct_dnssec_zone::names, ldns_struct_dnssec_name::nsec, ldns_struct_dnssec_name::nsec_signatures, and ldns_struct_dnssec_name::rrsets.

void ldns_dnssec_name_print_fmt | ( | FILE * | out,
|  | const ldns_output_format * | fmt,
|  | ldns_dnssec_name * | name
| ) |  |

Prints the RRs in the dnssec name structure to the given file descriptor.

Parameters

  [in] | out | the file descriptor to print to
  [in] | fmt | the format of the textual representation
  [in] | name | the name structure to print the contents of

Definition at line 555 of file dnssec_zone.c.

void ldns_dnssec_name_print | ( | FILE * | out,
|  | ldns_dnssec_name * | name
| ) |  |

Prints the RRs in the dnssec name structure to the given file descriptor.

Parameters

  [in] | out | the file descriptor to print to
  [in] | name | the name structure to print the contents of

Definition at line 562 of file dnssec_zone.c.

References ldns_dnssec_name_print_fmt(), and ldns_output_format_default.

ldns_dnssec_zone* ldns_dnssec_zone_new | ( | void |  | ) |

Creates a new dnssec_zone structure.

Returns
  the allocated structure

Definition at line 569 of file dnssec_zone.c.

References ldns_struct_dnssec_zone::_nsec3params, ldns_struct_dnssec_zone::hashed_names, LDNS_MALLOC, ldns_rdf2rr_type(), ldns_rr_get_type(), ldns_rr_rrsig_typecovered(), LDNS_RR_TYPE_RRSIG, ldns_struct_dnssec_zone::names, and ldns_struct_dnssec_zone::soa.

ldns_status ldns_dnssec_zone_new_frm_fp_l | ( | ldns_dnssec_zone ** | z,
|  | FILE * | fp,
|  | ldns_rdf * | origin,
|  | uint32_t | ttl,
|  | ldns_rr_class c | __attribute__(unused),
|  | int * | line_nr
| ) |  |

Definition at line 597 of file dnssec_zone.c.

References ldns_dnssec_zone_add_empty_nonterminals(), ldns_dnssec_zone_add_rr(), ldns_dnssec_zone_free(), ldns_dnssec_zone_new(), ldns_rdf_clone(), ldns_rdf_deep_free(), ldns_rr_list_free(), ldns_rr_list_new(), ldns_rr_list_push_rr(), ldns_rr_list_rr(), ldns_rr_list_rr_count(), ldns_rr_new_frm_fp_l(), LDNS_RR_TYPE_NSEC3, LDNS_STATUS_DNSSEC_NSEC3_ORIGINAL_NOT_FOUND, LDNS_STATUS_MEM_ERR, LDNS_STATUS_OK, LDNS_STATUS_SYNTAX_EMPTY, LDNS_STATUS_SYNTAX_INCLUDE, LDNS_STATUS_SYNTAX_INCLUDE_ERR_NOTIMPL, LDNS_STATUS_SYNTAX_ORIGIN, LDNS_STATUS_SYNTAX_TTL, ldns_zone_free(), ldns_zone_new_frm_fp_l(), ldns_zone_rrs(), and ldns_zone_soa().

ldns_status ldns_dnssec_zone_new_frm_fp | ( | ldns_dnssec_zone ** | z,
|  | FILE * | fp,
|  | ldns_rdf * | origin,
|  | uint32_t | ttl,
|  | ldns_rr_class c | __attribute__(unused)
| ) |  |

Definition at line 728 of file dnssec_zone.c.

References ldns_rbnode_t::data, ldns_dnssec_name_deep_free(), ldns_dnssec_name_free(), ldns_dnssec_zone_new_frm_fp_l(), and LDNS_FREE.

void ldns_dnssec_zone_free | ( | ldns_dnssec_zone * | zone | ) |

Frees the given zone structure, and its rbtree of dnssec_names Individual ldns_rr RRs within those names are not freed.

Parameters

  [in] | *zone | the zone to free

Definition at line 749 of file dnssec_zone.c.

References LDNS_FREE, ldns_traverse_postorder(), and ldns_struct_dnssec_zone::names.

void ldns_dnssec_zone_deep_free | ( | ldns_dnssec_zone * | zone | ) |

Frees the given zone structure, and its rbtree of dnssec_names Individual ldns_rr RRs within those names are also freed.

Parameters

  [in] | *zone | the zone to free

Definition at line 764 of file dnssec_zone.c.

References LDNS_FREE, ldns_traverse_postorder(), and ldns_struct_dnssec_zone::names.

int ldns_dname_compare_v | ( | const void * | a,
|  | const void * | b
| ) |  |

Given in dnssec_zone.c, also used in dnssec_sign.c:w.

Definition at line 780 of file dnssec_zone.c.

References ldns_struct_dnssec_zone::_nsec3params, ldns_rbnode_t::data, ldns_struct_dnssec_name::hashed_name, ldns_struct_dnssec_zone::hashed_names, ldns_rbnode_t::key, ldns_dname_compare(), ldns_dname_compare_v(), ldns_dname_label(), LDNS_FREE, LDNS_MALLOC, ldns_nsec3_hash_name_frm_nsec3(), ldns_rbtree_create(), ldns_rbtree_first(), ldns_rbtree_insert(), ldns_rbtree_next(), LDNS_RBTREE_NULL, ldns_rbtree_search(), ldns_rdf_deep_free(), ldns_rr_get_type(), ldns_rr_owner(), LDNS_RR_TYPE_NSEC3, ldns_traverse_postorder(), ldns_struct_dnssec_name::name, and ldns_struct_dnssec_zone::names.

ldns_status ldns_dnssec_zone_add_rr | ( | ldns_dnssec_zone * | zone,
|  | ldns_rr * | rr
| ) |  |

Adds the given RR to the zone.

It find whether there is a dnssec_name with that name present. If so, add it to that, if not create a new one. Special handling of NSEC and RRSIG provided

Parameters

  [in] | zone | the zone to add the RR to
  [in] | rr | The RR to add

Returns
  LDNS_STATUS_OK on success, an error code otherwise

Definition at line 880 of file dnssec_zone.c.

References ldns_rbnode_t::data, ldns_rbnode_t::key, ldns_dname_compare_v(), ldns_dnssec_name_add_rr(), ldns_dnssec_name_free(), ldns_dnssec_name_new_frm_rr(), LDNS_MALLOC, ldns_rbtree_create(), ldns_rbtree_insert(), ldns_rbtree_search(), ldns_rdf2rr_type(), ldns_rr_get_type(), ldns_rr_owner(), ldns_rr_rrsig_typecovered(), LDNS_RR_TYPE_NSEC3, LDNS_RR_TYPE_RRSIG, LDNS_RR_TYPE_SOA, LDNS_STATUS_DNSSEC_NSEC3_ORIGINAL_NOT_FOUND, LDNS_STATUS_ERR, LDNS_STATUS_MEM_ERR, LDNS_STATUS_OK, ldns_struct_dnssec_zone::names, and ldns_struct_dnssec_zone::soa.

void ldns_dnssec_zone_names_print_fmt | ( | FILE * | out,
|  | const ldns_output_format * | fmt,
|  | ldns_rbtree_t * | tree,
|  | bool | print_soa
| ) |  |

Definition at line 934 of file dnssec_zone.c.

References ldns_rbnode_t::data, ldns_struct_output_format::flags, LDNS_COMMENT_LAYOUT, ldns_rbtree_first(), ldns_rbtree_next(), and LDNS_RBTREE_NULL.

void ldns_dnssec_zone_names_print | ( | FILE * | out,
|  | ldns_rbtree_t * | tree,
|  | bool | print_soa
| ) |  |

Definition at line 952 of file dnssec_zone.c.

References ldns_dnssec_zone_names_print_fmt(), and ldns_output_format_default.

void ldns_dnssec_zone_print_fmt | ( | FILE * | out,
|  | const ldns_output_format * | fmt,
|  | ldns_dnssec_zone * | zone
| ) |  |

Prints the complete zone to the given file descriptor.

Parameters

  [in] | out | the file descriptor to print to
  [in] | fmt | the format of the textual representation
  [in] | zone | the dnssec_zone to print

Definition at line 959 of file dnssec_zone.c.

References ldns_struct_output_format::flags, LDNS_COMMENT_LAYOUT, ldns_dnssec_name_find_rrset(), ldns_dnssec_name_name(), ldns_dnssec_rrsets_print_fmt(), ldns_dnssec_zone_names_print_fmt(), ldns_rdf_print(), LDNS_RR_TYPE_SOA, ldns_struct_dnssec_zone::names, and ldns_struct_dnssec_zone::soa.

void ldns_dnssec_zone_print | ( | FILE * | out,
|  | ldns_dnssec_zone * | zone
| ) |  |

Prints the complete zone to the given file descriptor.

Parameters

  [in] | out | the file descriptor to print to
  [in] | zone | the dnssec_zone to print

Definition at line 987 of file dnssec_zone.c.

References ldns_dnssec_zone_print_fmt(), and ldns_output_format_default.

ldns_status ldns_dnssec_zone_add_empty_nonterminals | ( | ldns_dnssec_zone * | zone | ) |

Adds explicit dnssec_name structures for the empty nonterminals in this zone.

(this is needed for NSEC3 generation)

Parameters

  [in] | zone | the zone to check for empty nonterminals return LDNS_STATUS_OK on success.

Definition at line 993 of file dnssec_zone.c.

References ldns_rbnode_t::data, ldns_rbnode_t::key, ldns_dname_clone_from(), ldns_dname_compare(), ldns_dname_label_count(), ldns_dnssec_name_free(), ldns_dnssec_name_new(), LDNS_MALLOC, ldns_rbtree_first(), ldns_rbtree_insert(), ldns_rbtree_next(), LDNS_RBTREE_NULL, ldns_rdf_deep_free(), LDNS_STATUS_ERR, LDNS_STATUS_MEM_ERR, LDNS_STATUS_OK, ldns_struct_dnssec_name::name, ldns_struct_dnssec_name::name_alloced, ldns_struct_dnssec_zone::names, and ldns_struct_dnssec_zone::soa.

bool ldns_dnssec_zone_is_nsec3_optout | ( | ldns_dnssec_zone * | zone | ) |

If a NSEC3PARAM is available in the apex, walks the zone and returns true on the first optout nsec3.

Parameters

  [in] | zone | the zone to check for nsec3 optout records return true when the zone has at least one nsec3 optout record.

Definition at line 1095 of file dnssec_zone.c.

References ldns_rbnode_t::data, ldns_dnssec_name_find_rrset(), ldns_nsec3_optout(), ldns_rbtree_first(), ldns_rbtree_next(), LDNS_RBTREE_NULL, ldns_rr_get_type(), LDNS_RR_TYPE_NSEC3, LDNS_RR_TYPE_NSEC3PARAM, ldns_struct_dnssec_zone::names, and ldns_struct_dnssec_zone::soa.